ifndef __LIBC_INC
 include libc.inc
endif

.xlist

IOBSIZE		equ 800000h	; 8MB copy buffer

_A_NORMAL	equ 80h
_A_RDONLY	equ 01h
_A_HIDDEN	equ 02h
_A_SYSTEM	equ 04h
_A_SUBDIR	equ 10h
_A_ARCH		equ 20h

SEEK_SET	equ 0
SEEK_CUR	equ 1
SEEK_END	equ 2

IO_SEARCHCASE	equ 0001h
IO_SEARCHHEX	equ 0002h
IO_SEARCHSET	equ 0004h
IO_SEARCHCUR	equ 0008h
IO_SEARCHMASK	equ 000Fh
IO_SEARCHSUB	equ 0020h

IO_RETURNLF	equ 0040h	; return line index on search
IO_STRINGB	equ 0080h	; String buffer
IO_CRYPT	equ 0100h	; Crypted file
IO_USEUPD	equ 0200h	; Progress
IO_UPDTOTAL	equ 0400h	; Add Read/Write size to total
IO_USECRC	equ 0800h	; Update CRC on read/write
IO_USEBITS	equ 1000h	; Align bits on read/write
IO_CLIPBOARD	equ 2000h	; Flush to clipboard
IO_MEMBUF	equ 4000h	; File in buffer or memory addr
IO_ERROR	equ 8000h	; Write fault

S_IOST		STRUC
ios_bp		dd ?
ios_i		dd ?
ios_c		dd ?
ios_size	dd ?
ios_flag	dd ?
ios_file	dd ?
ios_l		dd ?
ios_bb		dd ?
ios_total	dq ?
ios_offset	dd ?
ios_fsize	dq ?
S_IOST		ENDS

externdef	STDI:S_IOST
externdef	STDO:S_IOST
externdef	crctab:dword
externdef	oupdate:size_p

oinitst		proto :dword, :dword
oopenst		proto :dword, :dword, :dword, :dword
oseekst		proto :dword, :dword, :dword
ocopyst		proto :dword, :dword, :qword
oflushst	proto :dword
ofreadst	proto :dword
oclose		proto :dword
ofreest		proto :dword
oputcst		proto ; edx, eax
ogetcst		proto ; eax
owritest	proto :dword, :dword, :dword
otellst		proto :dword	; DWORD
otell64		proto :dword	; QWORD


oupdcrc		proto
otell		proto
owrite		proto
oread		proto
oputc		proto
ogetc		proto
continuesearch  proto
osearch		proto
oflush		proto
ofread		proto
oreadb		proto :dword, :dword
oungetc		proto

oprintf		proto c :dword, :VARARG
ogetl		proto :dword, :dword, :size_t
ogets		proto
oputs		proto :dword
oopen		proto :dword, :size_t, :size_t
close		proto :size_t
ogetouth	proto :dword, :dword
openfile	proto :dword, :size_t, :size_t
oseek		proto :dword, :size_t
oseekl		proto :dword, :size_t

.list
