include io.inc
include fblk.inc
include string.inc
include filter.inc

	public  filter
	public  filter_fblk
	public  filter_wblk

	.data
	filter  dd 0

	.code

binary: ; CX = flag, AX = date, BX:DX = size
	mov	esi,filter
	test	esi,esi
	jz	binary_ok
	cmp	eax,[esi].S_FILT.of_min_date
	jb	binary_fail
	cmp	[esi].S_FILT.of_max_date,0
	je	binary_min
	cmp	eax,[esi].S_FILT.of_max_date
	ja	binary_fail
    binary_min:
	cmp	edx,[esi].S_FILT.of_min_size
	jb	binary_fail
    binary_max:
	mov	eax,[esi].S_FILT.of_max_size
	test	eax,eax
	jz	binary_03
	cmp	edx,eax
	ja	binary_fail
    binary_03:
	mov	eax,ecx
	and	ax,[esi]
	cmp	eax,ecx
	jne	binary_fail
    binary_ok:
	xor	eax,eax
	inc	eax
    binary_end:
	ret
    binary_fail:
	xor	eax,eax
	jmp	binary_end

string:
	xor	eax,eax
	cmp	al,[esi].S_FILT.of_include
	je	string_01
	invoke  cmpwargs,ebx,addr [esi].S_FILT.of_include
	jz	string_02
	xor	eax,eax
    string_01:
	cmp	al,[esi].S_FILT.of_exclude
	je	string_03
	invoke  cmpwargs,ebx,addr [esi].S_FILT.of_exclude
	jz	string_03
    string_02:
	xor	eax,eax
	ret
    string_03:
	xor	eax,eax
	inc	eax
	ret

filter_fblk proc uses esi ebx fb:dword
	mov	ebx,fb
	mov	eax,[ebx].S_FBLK.fb_time
	mov	ecx,[ebx].S_FBLK.fb_flag
	mov	edx,dword ptr [ebx].S_FBLK.fb_size
;	mov	rbx,dword ptr [rbx].S_WFBLK.wf_size[4] - not used..
	call	binary
	jz	@F
	test	esi,esi
	jz	@F
	mov	ebx,fb
	add	ebx,S_FBLK.fb_name
	call	string
      @@:
	test	eax,eax
	ret
filter_fblk endp

filter_wblk proc uses esi ebx wf:dword
	mov	ebx,wf
	mov	eax,dword ptr [ebx].S_WFBLK.wf_time
	mov	ecx,[ebx].S_WFBLK.wf_attrib
	mov	edx,dword ptr [ebx].S_WFBLK.wf_size
	mov	ebx,dword ptr [ebx].S_WFBLK.wf_size[4]
	call	binary
	jz	filter_wblk_00
	test	esi,esi
	jz	filter_wblk_00
	mov	ebx,wf
	add	ebx,S_WFBLK.wf_name
	call	string
    filter_wblk_00:
	test	eax,eax
	ret
filter_wblk endp

	END
